//-------------------------------------------------------------------------
/*                              gamep.h
                  Additional code for Duke3dw by ProAsm
                 Created June 2009 for MinGW compiling etc
*/
//-------------------------------------------------------------------------
/*
Watcom 1.8 changes:

1. Remark out boolen in rpcndr.h line 40
2. Remove #define WIN32_LEAN_AND_MEAN in compat.c line 16
3.
//-------------------------------------------------------------------------
DNBLUKEY - adds the Blue key.
DNREDKEY - adds the Red key.
DNYELKEY - adds the Yellow key.
DNGOD - God mode
DNGUN#
Where # =
2 - Adds pistol with 20 ammo
3 - Adds shotgun with 10 ammo
4 - Adds chaingun with 20 ammo
5 - Adds rpg with 5 ammo
6 - Adds handbomb with 6 ammo
7 - Adds shrinker with 5 ammo
8 - Adds devistator with 10 ammo
9 - Adds lazermines with 3 ammo
0 - Adds freezer with 10 ammo

DNFLY - Adds jetpack with 25% flight
DNMEDIC - Adds healthbox with 25% health
DNSWIM - Adds scuba tanks with 25% air

HRP loading process..........................
1. Search for duke3d_hrp.zip
2. If (1) not found, search for duke3d_mrp.zip
3. If (1) or (2) not found, search for duke3d_lrp.zip
4. If (1), (2) or (3) not found, search for Highres/duke3d_hrp.def
5. If (1), (2), (3) or (4)not found, search for Medres/duke3d_mrp.def
6. If (1), (2), (3), (4) or (5) not found, search for Lowres/duke3d_lrp.def

*/
//-------------------------------------------------------------------------
//

#define D3wVer "4.1.0"
#define D3wRev " - Revision  331.231"

char **HEAD2W = "Duke3dw Version "D3wVer;
char Userconfilename[128];
char Addonconfilename[128];

int32 bGrp = 0;
int32 bMap = 0;
int32 bfake = 0;

char *bf[128];
char MapMusic[128];
char MapMusicPath[128];
char boardmapname[80] = {0};
long autotick=0;
short iJet=0, iMedic=0, iTank=0;

int DnwGrp;
static char *userdef = "";
long save_totalclock;

extern char  MusicFolder[80];
extern char  MapsFolder[80];
extern char  GameFolder[80];

extern char  MenuMap[80];
extern char  MenuMusic[80];
extern char  MenuGame[80];
extern char  GameMap[40];

extern char  UserSaves[10][80];
extern char  UserMusic[100][32];
extern short UserSavenum;
extern short iLevelNum;
extern short iSkill;

extern char  Botname[8][32];
extern char  IPAddress[32];
extern short SelectMulti;
extern short HostMulti;
extern short FakePlayer;
extern short NumBots;
extern short NumPlayerArg;
extern short DedicatedArg;

const char **argvline;

//------------------------------------------------------------------

void microtext(int x, int y, char *t, long p, short sb)
{
    short ac;
    char ch;

	if (!Bstrncasecmp(t, "0", 1))
        return;

    if (!ud.weaponicons)
        return;

    if (!usehightile)
        return;

    if (!DnwGrp)
        return;

	sb &= 255;

    while(*t)
    {
        ch = Btoupper(*t);
        if (ch == 32) {x += 5; t++; continue;}
        else
            ac = ch - '!' + MINIFONT;

		rotatesprite(sbarx(x),sbary(y),sbarsc(32768L),0,ac,0,p,sb,0,0,xdim-1,ydim-1);
        x += 2;
        t++;
    }
}

void UpdateMiniBarWeapons(struct player_struct *p, short Weapnum)    // wxwp
{
    short i, x, y;
    int   weaps[10] = {21, 28, 22, 23, 26, 25, 29, 27, 24, 32};
    int   wsize[10] = {20000,14000,15000,15000,8000,12000,18000,22000,18000,12000};
    short xp[10] = {124,146,168,192,212,232,256,278,300,212};
    int   wp[10], wc[10];

    if (!ud.weaponicons)
        return;

    if (Weapnum == 11)     // expander
        Weapnum = 6;       // show shrinker

    for (i=0; i<10; i++)
    {
        wp[i] = 32;
        wc[i] = 0;
        if (p->gotweapon[i])
        {
           if (p->ammo_amount[i] > 0)
           {
              wp[i] = 22;
              wc[i] = 14;
           }
        }
    }
    if  (Weapnum > 0 && Weapnum < 10)
    {
        wp[Weapnum] = 0;
        wc[Weapnum] = 13;
    }

    // rotatesprite(long sx, long sy, long z, short a, short picnum, signed char dashade, char dapalnum, char dastat, long cx1, long cy1, long cx2, long cy2)
    // Pistol
    x = 120;
    y = 191;
        rotatesprite(sbarx(x),sbary(y+1),wsize[0], 0, weaps[0],   wp[1], wc[1], 10+16, 0, 0, xdim - 1, ydim - 1);
    // Shotgun
    x = 139;
    y = 192;
        rotatesprite(sbarx(x),sbary(y+1),wsize[1], 0, weaps[1],  wp[2], wc[2], 10+16, 0, 0, xdim - 1, ydim - 1);
    // Chaingun
    x = 162;
    y = 191;
        rotatesprite(sbarx(x),sbary(y),wsize[2], 0, weaps[2], wp[3], wc[3], 10+16, 0, 0, xdim - 1, ydim - 1);
    // RPG
    x = 186;
    y = 192;
        rotatesprite(sbarx(x),sbary(y),wsize[3], 0, weaps[3],   wp[4], wc[4], 10+16, 0, 0, xdim - 1, ydim - 1);
    // Handbomb
    x = 208;
    y = 191;
        rotatesprite(sbarx(x),sbary(y+1),wsize[4], 0, weaps[4], wp[5], wc[5], 10+16, 0, 0, xdim - 1, ydim - 1);
    // Shrinker
    x = 225;
    y = 192;
    if (p->curr_weapon == GROW_WEAPON) // Expander
    {
        y = 189;
        rotatesprite(sbarx(x),sbary(y),wsize[9], 0, weaps[9], wp[6], wc[6], 10+16, 0, 0, xdim - 1, ydim - 1);
    }
    else
        rotatesprite(sbarx(x),sbary(y),wsize[5], 0, weaps[5], wp[6], wc[6], 10+16, 0, 0, xdim - 1, ydim - 1);
    // Devistator
    x = 247;
    y = 191;
        rotatesprite(sbarx(x),sbary(y),wsize[6], 0, weaps[6], wp[7], wc[7], 10+16, 0, 0, xdim - 1, ydim - 1);
    // Lazermine
    x = 274;
    y = 192;
        rotatesprite(sbarx(x),sbary(y),wsize[7], 0, weaps[7], wp[8], wc[8], 10+16, 0, 0, xdim - 1, ydim - 1);
    // Freezer
    x = 291;
    y = 190;
       rotatesprite(sbarx(x),sbary(y),wsize[8], 0, weaps[8],   wp[9], wc[9], 10+16, 0, 0, xdim - 1, ydim - 1);

    for (i=0; i<9; i++)
    {
         sprintf(bf, "%d", p->ammo_amount[i+1]);
         x = 22;
         if (Weapnum == i+1)
             x = 6;
         microtext(xp[i],193,bf,x,10+16+256);
    }
}

int CheckScreenMode(void)                                           // wierd - must stay
{
    if (DnwGrp == 0 || ScreenBPP == 8 || usehightile == 0)
        ud.weaponicons = 1;
    return 0;
}

void checkforhrp(char *pth)
{
    char *tmp = pth;
    char px[128];
    int i, k, x;

    strlwr(pth);                            // convert to lower case strlwr(*buff) strupr(*buff)
    k = strstr(tmp, ".map");

    if (bGrp && k > 0)                      // incase a .grp has a -map
        return;

    if (strchr(pth,'.') != 0)
    {
       x = strlen(pth);

       for (i=0; i<128; i++)
            px[i] = 0;

       strcpy(px, pth);
       px[x-4] = 0;
       strcat(px, "_hrp.zip");
       k = initgroupfile(px);               // check for TCName/MapName.hrp
       if (k >= 0)
       {
           initprintf("Adding Custom Hrp: %s\n", px);
           for (i=0; i<128; i++)
                px[i] = 0;
           strncpy(px, pth, x-4);
           px[x-4] = 0;
           strcat(px, ".def");
           if (!loaddefinitionsfile(px))   // check for custom TCName/MapName.def
               initprintf("Adding Custom Def: %s\n", px);
       }

       for (i=0; i<128; i++)
            px[i] = 0;
       strncpy(px, pth, x-4);
       px[x-4] = 0;
       strcat(px, "_addon.zip");
       k = initgroupfile(px);               // check for TCName_addon.zip
       if (k >= 0)
       {
           initprintf("Adding Custom TC_Addon: %s\n", px);
           for (i=0; i<128; i++)
                px[i] = 0;
           strncpy(px, pth, x-4);
           px[x-4] = 0;
           strcat(px, "_addon.con");
           tmp = px;

           if (strchr(tmp, '/') != 0)
               strcpy(Addonconfilename, strrchr(tmp, '/')+1);
           else
           if (strchr(tmp, '\\') != 0)
               strcpy(Addonconfilename, strrchr(tmp, '\\')+1);
           else
               strcpy(Addonconfilename, tmp);
           i = kopen4load(Addonconfilename, 0);
           if (i == -1)
               Addonconfilename[0] = 0;
           kclose(i);
       }
    }
}

void VerifyConfiles(void)
{
    int i;

    if (Userconfilename[0] != 0)
    {
        i = kopen4load(Userconfilename, 0);
        if (i == -1)
        {
            i = strlen(Userconfilename);
            Userconfilename[i-4] = 0;
            strcat(Userconfilename, ".gam");                         // some have .gam
            i = kopen4load(Userconfilename, 0);
            if (i != -1)
            {
                strcpy(confilename, Userconfilename);
            }
        }
        else
        {
            strcpy(confilename, Userconfilename);
        }
        kclose(i);
    }
    if (Addonconfilename[0] != 0)
    {
        i = kopen4load(Addonconfilename, 0);
        if (i != -1)
        {
            strcpy(confilename, Addonconfilename);
        }
        kclose(i);
    }
    if (confilename[0] != 0)
    {
        i = kopen4load(confilename, 0);
        if (i == -1)
        {
            confilename = "game.con";
        }
        kclose(i);
    }
}

void getboardmapname(char *sMap)
{

    if (strchr(sMap, '/') == 0)
    {
       if (strchr(sMap, '\\') == 0)
           strcpy(boardmapname, sMap);
       else
           strcpy(boardmapname, strrchr(sMap, '\\')+1);
    }
    else
       strcpy(boardmapname, strrchr(sMap, '/')+1);
}

// typ: 0 = -g (grp) | 1 = -x (con) | 2 = -h (def) | 3 = -map | 4 = path only | 5 = music
void checksearchpath(char *pth, int typ)
{
    unsigned char ph[128];
    unsigned char px[128];
    unsigned char nm[128];
    int i, j, k, x;

    px[0] = 0;
    nm[0] = 0;

    if (strchr(pth,'\\') != 0 || strchr(pth,'/') != 0)
    {
        for (i=0; i<128; i++)
        {
            px[i] = 0;
            ph[i] = 0;
            nm[i] = 0;
        }

        strcpy(ph, pth);
        x = strlen(pth);

        for (i=x; i>0; i--)
        {
            if (ph[i] == '\\' || ph[i] == '/')
                break;
        }

        for (j=0; j<i; j++)
        {
            px[j] = ph[j];          // extract the path
        }

        addsearchpath(px);

        i++;
        k = 0;
        for (j=i; j<x; j++)
        {
            nm[k] = ph[j];          // extract the name
            k++;
        }
    }
    else
    {
        strcpy(nm, pth);
    }

    if (typ == 4)     // path only
        return;

    if (typ == 5)                                                 // -music
    {

       x = strlen(nm);
       if (px[0] == 0)
       {
           addsearchpath("music");
           sprintf(bf, "music/%s", nm);
       }
       else
           sprintf(bf, "%s/%s", px, nm);
       i = kopen4load(bf, 0);            // check if it exists
       if (i != -1 && MapMusic[0] == 0)
       {
           strcpy(MapMusicPath, px);     // path or null
           strcpy(MapMusic, nm);         // music file
       }
       kclose(i);
    }
}

void PauseAction(void)
{
    ready2send = 0;
    save_totalclock = totalclock;
}

void ResumeAction(void)
{
    ready2send = 1;
    totalclock = save_totalclock;
}


void AutoSaveGame(short disp)
{
    long x;

    if (ud.multimode < 2 && ud.autosave > 0)
    {
        if (disp == 1)
        {
           strcpy(fta_quotes[122],"AUTOSAVED GAME");
           FTA(122,&ps[myconnectindex]);
        }
        autotick = totalclock + 200;   // 1.7 second delay
        ud.autodone = 1;
    }
}

void DelayedAutoSave(void)
{
    if (totalclock >= autotick && autotick > 0)
    {
        autotick = 0;
        PauseAction();
        screencapt = 1;
        displayrooms(myconnectindex,65536);
        screencapt = 0;
        saveplayer(10);
        ResumeAction();
    }
}

int DeleteAutosave(short iEnd)
{
    FILE *fil;

    fil = kopen4load("gamex.asv", 0);
    if (fil)
    {
        kclose(fil);
        DeleteFile("gamex.asv");
        if (iEnd == 1 && ud.multimode < 2)
            initprintf("  - Game End: Autosave deleted.\n");
    }
    return 0;
}

long SetupUserMap()
{
    long i;
    char mp[40];

    mp[0] = 0;
    if (MenuMusic[0] != 0)
        sprintf(mp,"-music %s/%s", MusicFolder, MenuMusic);
    sprintf(bf, "Duke3dw.exe -map %s/%s -s%d %s", MapsFolder, MenuMap, iSkill, mp);
    argvline = strdup(bf);
    i = SetCommandLine(argvline);
    return i;
}

long SetupUserGame()
{
    long i;
    char *con[4];
    char mp[40];
    char mu[80];
    char sBuff[80];

    i = strlen(MenuGame);   // .grp or .zip
    if (i > 4)
    {
       strcpy(sBuff, MenuGame);
       sBuff[i-4] = 0;
       mp[0] = 0;
       mu[0] = 0;

       strcpy(con, "gam");
       sprintf(bf, "%s\\%s.gam", GameFolder, sBuff);
       i = kopen4load(bf,0);       // if a .gam file does not exist
       if (i == -1)
           strcpy(con, "con");     // make it a standard .con
       kclose(i);

       if (strlen(GameMap) > 4)
       {
           if (MenuMusic[0] != 0)
               sprintf(mu," -music %s/%s", MusicFolder, MenuMusic);
           sprintf(mp," -map %s -s%d%s", GameMap, iSkill, mu);
       }
       sprintf(bf, "Duke3dw.exe -g%s/%s -x%s.%s%s", GameFolder, MenuGame, sBuff, con, mp);
       argvline = strdup(bf);
       i = SetCommandLine(argvline);
       return i;
    }
    return 0;
}

long SetupUserLevel(short lnum)
{
   long v, i;

   v = 1;
   i = lnum;
   if (lnum > 11)
   {
       v = lnum / 11;
       i = lnum - v * 11;
       v++;
       if (i == 0)
       {
           v--;
           i = 11;
       }
   }
   sprintf(bf, "Duke3dw.exe -v%d -l%d -s%d", v, i, iSkill);
   argvline = strdup(bf);
   i = SetCommandLine(argvline);
   return i;
}

long SetupUserSavedGame(short snum)
{
    long i;

    sprintf(bf, "Duke3dw.exe -%d", snum);
    argvline = strdup(bf);
    i = SetCommandLine(argvline);
    return i;
}

long SetupMultiPlayer()
{
    char mbuf[80];
    char brac[2];
    long i;

    mbuf[0] = 0;
    brac[0] = 0;
    if (MapsFolder[0] != 0)
        strcpy(brac, "/");

    if (MenuMap[0] != 0)
    {
        sprintf(bf, "-map %s%s%s", MapsFolder, brac, MenuMap);
        strcpy(mbuf, bf);
    }

    if (DedicatedArg == 1)
    {
        if (HostMulti == 1)
            sprintf(bf, "Duke3dw.exe %s /name %s /net /n0:%d", mbuf, PlayerNameArg, NumPlayerArg);
        else
            sprintf(bf, "Duke3dw.exe %s /name %s /net /n0 %s", mbuf, PlayerNameArg, IPAddress);
    }
    else
    {
        if (HostMulti == 1)
            sprintf(bf, "Duke3dw.exe %s /name %s /net /n1 %s", mbuf, PlayerNameArg, IPAddress);
        else
            sprintf(bf, "Duke3dw.exe %s /name %s /net %s /n1", mbuf, PlayerNameArg, IPAddress);
    }

    argvline = strdup(bf);
    i = SetCommandLine(argvline);
    return i;
}

long SetupFakeMultiPlayer()
{
    char musc[80];
    char mbuf[80];
    char brac[2];
    long i;

    mbuf[0] = 0;
    musc[0] = 0;
    brac[0] = 0;

    if (MapsFolder[0] != 0)
        strcpy(brac, "/");

    if (MenuMap[0] != 0)
    {
        sprintf(bf, "-map %s%s%s", MapsFolder, brac, MenuMap);
        strcpy(mbuf, bf);
    }

    if (MenuMusic[0] != 0)
    {
        sprintf(bf, " -music %s/%s", MusicFolder, MenuMusic);
        strcpy(musc, bf);
    }

    sprintf(bf, "Duke3dw.exe %s /name %s /q%d /a /m /s%d%s", mbuf, PlayerNameArg, NumBots+1, iSkill, musc);

    argvline = strdup(bf);
    i = SetCommandLine(argvline);
    bfake = 1;
    return i;
}

void CheckFakePlayers(void)
{
    short i;

    if (FakePlayer)
    {
        strcpy(ud.user_name[0], PlayerNameArg);
        for (i=1; i<8; i++)
        {
             if (Botname[i] != 0)
                 strcpy(ud.user_name[i], Botname[i]);
             else
             {
                sprintf(tempbuf, "Bot %d", i);
                strcpy(ud.user_name[i], tempbuf);
             }
        }
    }
}

long RemoveMapInfo(long argx)
{
    char xbuf[128];
    short i;

    argvline = NULL;
    strcpy(xbuf, _buildargv[0]);
    for (i=3; i<argx; i++)
    {
         strcat(xbuf, " ");
         strcat(xbuf, _buildargv[i]);
    }

    sprintf(bf, "%s", xbuf);
    argvline = strdup(bf);

    if (strlen(bf) > 20)
    {
        argx = SetCommandLine(argvline);
        _buildargc = argx;
    }

    return argx;
}

void CheckMultiplayer(void)
{
	if (numplayers > 1)
	    initprintf("Multiplayer initialized.\n");

	if (netparam)
	    free(netparam);
	netparam = NULL;
	netparamcount = 0;

	getnames();
}

int DetectShareware(void)
{
    long L;
    int  h;

    h = kopen4load("duke3d.grp", 0);      // retail 13 = 26524524 | retail 15 = 44356548 | shareware = 11035779
    if (h >= 0)
    {
    L = kfilelength(h);
    if (L == 26524524 || L == 44356548)
        return 0;
    else
       {
	   shareware = 1;
	   kclose(h);
	   return 1;
	   }
    }
    return 0;
}

